/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2012-12-18 18:49:29,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.nexus.configuration.model.v1_0_3;

/**
 * The security section of Nexus configuration.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class CSecurity
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The only mandatory element. If true, Nexus instance will be
     * secured.
     */
    private boolean enabled = false;

    /**
     * 
     *             If enabled, the users will be able to access DAV
     * resources unauthenticated, if Realm allows. To
     *             set
     *             rights for
     *             unauthenticated users, use "anonymous" username.
     *           
     */
    private boolean anonymousAccessEnabled = false;

    /**
     * The authentication source to use with Nexus.
     */
    private CAuthSource authenticationSource;

    /**
     * Field realms.
     */
    private java.util.List<CAuthzSource> realms;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addRealm.
     * 
     * @param cAuthzSource
     */
    public void addRealm( CAuthzSource cAuthzSource )
    {
        getRealms().add( cAuthzSource );
    } //-- void addRealm( CAuthzSource )

    /**
     * Get the authentication source to use with Nexus.
     * 
     * @return CAuthSource
     */
    public CAuthSource getAuthenticationSource()
    {
        return this.authenticationSource;
    } //-- CAuthSource getAuthenticationSource()

    /**
     * Method getRealms.
     * 
     * @return List
     */
    public java.util.List<CAuthzSource> getRealms()
    {
        if ( this.realms == null )
        {
            this.realms = new java.util.ArrayList<CAuthzSource>();
        }

        return this.realms;
    } //-- java.util.List<CAuthzSource> getRealms()

    /**
     * Get if enabled, the users will be able to access DAV
     * resources unauthenticated, if Realm allows. To
     *             set
     *             rights for
     *             unauthenticated users, use "anonymous" username.
     * 
     * @return boolean
     */
    public boolean isAnonymousAccessEnabled()
    {
        return this.anonymousAccessEnabled;
    } //-- boolean isAnonymousAccessEnabled()

    /**
     * Get the only mandatory element. If true, Nexus instance will
     * be secured.
     * 
     * @return boolean
     */
    public boolean isEnabled()
    {
        return this.enabled;
    } //-- boolean isEnabled()

    /**
     * Method removeRealm.
     * 
     * @param cAuthzSource
     */
    public void removeRealm( CAuthzSource cAuthzSource )
    {
        getRealms().remove( cAuthzSource );
    } //-- void removeRealm( CAuthzSource )

    /**
     * Set if enabled, the users will be able to access DAV
     * resources unauthenticated, if Realm allows. To
     *             set
     *             rights for
     *             unauthenticated users, use "anonymous" username.
     * 
     * @param anonymousAccessEnabled
     */
    public void setAnonymousAccessEnabled( boolean anonymousAccessEnabled )
    {
        this.anonymousAccessEnabled = anonymousAccessEnabled;
    } //-- void setAnonymousAccessEnabled( boolean )

    /**
     * Set the authentication source to use with Nexus.
     * 
     * @param authenticationSource
     */
    public void setAuthenticationSource( CAuthSource authenticationSource )
    {
        this.authenticationSource = authenticationSource;
    } //-- void setAuthenticationSource( CAuthSource )

    /**
     * Set the only mandatory element. If true, Nexus instance will
     * be secured.
     * 
     * @param enabled
     */
    public void setEnabled( boolean enabled )
    {
        this.enabled = enabled;
    } //-- void setEnabled( boolean )

    /**
     * Set the list of realms used to Nexus.
     * 
     * @param realms
     */
    public void setRealms( java.util.List<CAuthzSource> realms )
    {
        this.realms = realms;
    } //-- void setRealms( java.util.List )

}
